Imports System
Imports System.ComponentModel
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Xml.Serialization
Imports Microsoft.SharePoint
Imports Microsoft.SharePoint.Utilities
Imports Microsoft.SharePoint. _
         WebPartPages

'/////////////////////////////////////////////////////////
'  Suntimes Web Part for SharePoint Portal Server
'  for Fawcette Technical Publications, Inc.
'  Original Web Part code  2004 Ken Cox (kjopc@hotmail.com)
'  Algorithm source:
'  National Oceanic and Atmospheric Administration Surface Radiation Research Branch:
'  http://www.srrb.noaa.gov/highlights/sunrise/sunrise.html
'  This version uses Toronto, Ontario, Canada as the default coordinates
'/////////////////////////////////////////////////////////

'Description for suntimes
<DefaultProperty("Text"), _
ToolboxData("<{0}:suntimes" & _
" runat=server>" & _
"</{0}:suntimes>"), _
XmlRoot(Namespace:="suntimes")> _
Public Class suntimes
  Inherits Microsoft.SharePoint. _
      WebPartPages.WebPart
  Dim lblLocation As Label
  Dim lblSunriseTime As Label
  Dim lblSunsetTime As Label
  Dim lblDate As Label
  Dim imgSunrise As Image
  Dim imgSunset As Image
  Dim lblAbout As Label
  Dim lblInstruction As Label

  Private Const _dfLoc As _
        String = "Toronto"
  Private Const _dfLat As _
        Double = 43.692
  Private Const _dfLng As _
        Double = 79.3716
  Private Const _dfTZ As _
        Double = 5
  Private Const _dfDst As _
        Boolean = False
  Private Const _dfAbout As _
        String = ""


  Dim _location As String = _dfLoc
  Dim _latitude As Double = _dfLat
  Dim _longitude As Double = _dfLng
  Dim _timezone As Double = _dfTZ
  Dim _dst As Boolean = _dfDst
  Dim _about As String = _dfAbout
  Dim _zones As [Enum]

  <Browsable(True), _
  Category("Sunrise/Set Config"), _
  DefaultValue(_dfLoc), _
  WebPartStorage(Storage.Personal), _
  FriendlyName("Location"), _
  Description("Enter the name" & _
        " of the city.")> _
  Property location() As String
    Get
      Return _location
    End Get

    Set(ByVal Value As String)
      If IsNothing(Value) Or _
          Value = "" Then
        Throw New _
        WebPartPageUserException _
        ("Please enter a " & _
        "location name.")
      End If
      _location = Value
    End Set
  End Property

  <Browsable(True), _
  Category("Sunrise/Set Config"), _
  DefaultValue(_dfLat), _
  WebPartStorage(Storage.Personal), _
  FriendlyName("Latitude"), _
  Description("Enter the latitude" & _
  " in decimal degrees " & _
  "(e.g., 43.692). " & _
  "Positive in Western Hemisphere," & _
  " negative in Eastern Hemisphere")> _
  Property latitude() As Double
    Get
      Return _latitude
    End Get

    Set(ByVal Value As Double)
      If Value < -90 Or Value > 90 Then
        Throw New _
        WebPartPageUserException _
         ("The Latitude value" & _
         " must be -90 to 90.")
        Value = 0
      End If
      _latitude = Value
    End Set
  End Property

  <Browsable(True), _
  Category("Sunrise/Set Config"), _
  DefaultValue(_dfLng), _
  WebPartStorage(Storage.Personal), _
  FriendlyName("Longitude"), _
  Description("Enter the longitude " & _
  "in decimal degrees." & _
  " (e.g., 79.3716). Positive " & _
  "for Northern hemisphere" & _
  ", negative for Southern.")> _
  Property longitude() As Double
    Get
      Return _longitude
    End Get

    Set(ByVal Value As Double)
      If Value < -180 Or _
        Value > 180 Then
        Throw New _
        WebPartPageUserException _
         ("The Longitude value " & _
         "must be -180 to 180.")
        Value = 0
      End If
      _longitude = Value
    End Set
  End Property

  <Browsable(True), _
  Category("Sunrise/Set Config"), _
  DefaultValue(_dfTZ), _
  WebPartStorage(Storage.Personal), _
  FriendlyName("Time Zone Offset"), _
  Description("Enter the " & _
  "difference in hours " & _
  "between your time zone and UTC " & _
  "(e.g., for Eastern time " & _
  "enter 5).")> _
  Property timezone() As Double
    Get
      Return _timezone
    End Get

    Set(ByVal Value As Double)
      If Value < -12 Or Value > 12 Then
        Throw New _
        WebPartPageUserException _
     ("The Time Zone Offset " & _
      "must be -12 to 12.")
        Value = 0
      End If
      _timezone = Value
    End Set
  End Property


  <Browsable(True), _
  Category("Sunrise/Set Config"), _
  DefaultValue(_dfDst), _
  WebPartStorage(Storage.Personal), _
  FriendlyName("Daylight Saving"), _
  Description("Check the " & _
  "box if your time " & _
  "zone is currently " & _
  "using Daylight " & _
  "Saving (or Summer) time.")> _
  Property dst() As Boolean
    Get
      Return _dst
    End Get

    Set(ByVal Value As Boolean)
      _dst = Value
    End Set
  End Property

  Public Overrides _
  Function GetToolParts() _
    As ToolPart()
    Dim toolPane As ToolPane

    Dim toolParts(2) As ToolPart
    Dim wptp As WebPartToolPart = _
      New WebPartToolPart
    Dim custom As _
      CustomPropertyToolPart = _
      New CustomPropertyToolPart
    custom.Expand("Sunrise/Set Config")
    toolParts(1) = wptp
    toolParts(0) = custom
    viewstate("sr") = Nothing
    Return toolParts
  End Function


  Protected Overrides _
  Sub RenderWebPart _
  (ByVal output As _
  System.Web.UI.HtmlTextWriter)
    EnsureChildControls()
    output.Write("<!-- Start of " & _
    "Sunrise/Sunset ")
    output.Write("Web Part by ")
    output.Write("Ken Cox-->")
    output.Write("<TABLE ")
    output.Write("cellpadding='1'>")
    output.Write("<tr><td ")
    output.Write(" colspan='2' ")
    output.Write("class=")
    output.Write("ms-smallheader ")
    output.Write("style='PADDING-TOP:")
    output.Write(" 6px' axis=axG0>")
    output.Write(" <SPAN class=''>")
    lblLocation.RenderControl(output)
    output.Write("</SPAN></td></tr>")
    output.Write("<tr><td colspan='2'>")
    lblDate.RenderControl(output)
    output.Write("</td></tr>")
    output.Write("<tr><td>")
    imgSunrise.RenderControl(output)
    output.Write("</td><td>")
    lblSunriseTime.RenderControl(output)
    output.Write("</td></tr><tr><td>")
    imgSunset.RenderControl(output)
    output.Write("</td><td>")
    lblSunsetTime.RenderControl(output)
    output.Write("</td></tr>")
    output.Write("</td></tr></TABLE>")
    output.Write("<!-- End of Sunrise")
    output.Write("/Sunset--> ")
  End Sub

  Protected Overrides _
  Sub CreateChildControls()
    Dim zenithvalue As String = "O"
    Dim sunrout As SunRoutines
    Dim sr As calculations
    Dim sb As New _
     System.Text.StringBuilder
    Try
      sunrout = New SunRoutines
      sr = New calculations
      If viewstate("sr") _
      Is Nothing Then
        sr = sunrout.GetSunriseSunset _
               (location, _
               latitude, _
               longitude, _
               timezone, _
               IIf(dst = True, 1, 0), _
               zenithvalue)
        viewstate("sr") = sr
      Else
        sr = viewstate("sr")
      End If

    Catch exc As Exception
      lblLocation = New Label
      sb.Append("<span class=")
      sb.Append("'ms-descriptiontext'>")
      sb.Append("Please provide " & _
      "valid values in the ")
      sb.Append("<a href=""javascript:")
      sb.Append("MSOTlPn_")
      sb.Append("ShowToolPaneWrapper")
      sb.Append("('1','129','")
      sb.Append(Me.UniqueID.ToString)
      sb.Append("');""> ")
      sb.Append("tool pane.</a>")
      lblLocation.Text = sb.ToString
      Exit Sub
    End Try

    lblLocation = New Label
    lblLocation.Text = sr.location
    lblLocation.CssClass = _
     "ms-announcementtitle"
    lblLocation.ToolTip = _
      "Latitude: " & _
    sr.latitude.ToString & _
     " / Longitude: " & _
     sr.longitude.ToString

    lblSunriseTime = New Label
    lblSunriseTime.Text = _
      sr.sunriseLocal.ToShortTimeString

    lblSunsetTime = New Label
    lblSunsetTime.Text = _
    sr.sunsetLocal.ToShortTimeString

    lblDate = New Label
    lblDate.Text = _
    sr.nowtimeLocal.ToLongDateString

    imgSunrise = New Image
    imgSunrise.ImageUrl = _
    MyBase.ClassResourcePath & _
      "/sunrise.gif"
    imgSunrise.ToolTip = "Sunrise"

    imgSunset = New Image
    imgSunset.ImageUrl = _
    MyBase.ClassResourcePath & _
      "/sunset.gif"
    imgSunset.ToolTip = "Sunset"
  End Sub

End Class
